#include "config.h"
#define __PWPLIB_C

#include <stdio.h>
#include <stdlib.h>

#include <signal.h>
#include <time.h>
#include <sys/time.h>

#include "pwplib.h"

void pwplib_dummy(){}

void pwplib_dump_rast_plain()
{
   u8 tmp[pwplib.videobuf.width*pwplib.videobuf.height*2],*d=tmp,
      *parentbuf=pwplib.videobuf.d,
      *s=parentbuf;

   int i=pwplib.videobuf.width*pwplib.videobuf.height;
   
   for(;i;i--)
   {
      d[0]=176; /* non-ibm uses '%' */
      d[1]=*s++;
      d+=2;
   }

   pwplib.videobuf.d=tmp;
   pwplib.dump_ibm();
   pwplib.videobuf.d=parentbuf;
}

#define TIMERHZ 72
int pwp_timer_nrt()
{
   static int lastctr=0,framectr=0;

   if(pwplib.setup[SETUP_BPS])
   {
      pwplib.timer_counter++; /* kludge */
      return (pwplib.timer_counter*TIMERHZ)/(pwplib.setup[SETUP_BPS]>>3);
   }
    else
   {
      if(pwplib.timer_counter!=lastctr)
      {
         framectr++;
         lastctr=pwplib.timer_counter;
      }
       else 
          pwplib.timer_counter++;
      return (framectr*TIMERHZ)/pwplib.setup[SETUP_FPS];
   }
}
int pwp_unix_tod()
{
        struct timeval tod;
        gettimeofday(&tod,NULL);
        return (tod.tv_sec*TIMERHZ)+(tod.tv_usec*TIMERHZ/1000000);
}
int pwplib_timer()
{
        static int base=-1;int v;
        v=pwplib.timerfunc();
        if(base==-1)base=v;
        return v-base;
}

/********************/

int pwplib_init()
{
   pwplib.sound=
   pwplib.loopflush=
   pwplib.player=
   pwplib.dump_ibm=
   pwplib.dump_rast=
     pwplib_dummy;

   /* video */

   if(pwplib.setup[SETUP_PVP])
     pvp_init();
   else
   if(!pwplib.setup[SETUP_NOVIDEO])
   {
     if(!pwplib.setup[SETUP_TTY])
     {
       if(!vcsa_init())
       {
          showsetup("\rcan't open /dev/vcsa - falling back to vt/ansi codes");
          pwplib.setup[SETUP_TTY]++;
       }
     }

     if(pwplib.setup[SETUP_TTY])
     {
        tty_init();
     }

     conv_init();
   }

   /* audio */
   if(!pwplib.setup[SETUP_NOSOUND])
   {
     if(!oss_init())
     {
       showsetup("\rcan't access sound device. switching to nosound.\n");
     }else
     {
       char tmp[100];
       sprintf(tmp,"\rsound settings: volume=%i\n",pwplib.setup[SETUP_VOLUME]);
       showsetup(tmp);
     }
   }
   else
   showsetup("\rno sound output.\n");

   if(pwplib.dump_rast==pwplib_dummy && pwplib.dump_ibm!=pwplib_dummy)
      pwplib.dump_rast=pwplib_dump_rast_plain;

   if(pwplib.setup[SETUP_BPS]|pwplib.setup[SETUP_FPS])
   {
      char tmp[100];
      sprintf(tmp,"\rnon-realtime output (bps=%d fps=%d)\n",
        pwplib.setup[SETUP_BPS],pwplib.setup[SETUP_FPS]);
      showsetup(tmp);

      pwplib.timerfunc=pwp_timer_nrt;
      pwplib.timer_counter=0;
   }
    else
      pwplib.timerfunc=pwp_unix_tod;

   return 1;
}
