#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "pwplib/pwplib.h"

#define VERSION "0.80"

/* final isi: */
  extern char auditype;      /* dos */
  extern char setup_rtc;     /* dos */
  extern char setup_force25; /* almost deprecated */
  extern char setup_nohibit; /* fg16, deprecated */
  extern char setup_english; /* useful */

char*pwpasciilogo=
"\033[2J\033[H\n"
"   \033[36;46mMMmmmmmmMM\033[0m\n"
"       \033[36;46mMM\033[0m\n"
"    \033[31;41mxxxxxxxxxxxx\033[0m\n"
"    \033[31;41mxxxxxxxxxxxxxxxxxxx\033[0m\n"
"   \033[31;41mxxxxxxxxx\033[0m\n"
"   \033[33;43mZZZZZ\033[34;44m....\033[0m        %%%%%%%%%  %%%        %%%  %%%%%%%%%\n"
"  \033[37;47m@@@@\033[34;44m......\033[0m        %%%%%%%%%. %%%....... %%%. %%%%%%%%%....\n"
"  \033[37;47m@@@@\033[34;44m....\033[37mo\033[34m.\033[0m   .....%%%   %%%  %%%   %%%  %%%  %%%   %%%\n"
" \033[37;47m@@@@@@@\033[34;44m....\033[0m        %%%   %%%  %%%   %%%  %%%  %%%   %%%\n"
" \033[37;47m@@@@@@@@@@@\033[0m        %%%%  %%%  %%%   %%%  %%%  %%%%  %%%\n"
" \033[37;47m@@@@@@@@@@@@@\033[0m      %%%%  %%%  %%%   %%%  %%%  %%%%  %%%\n"
" \033[37;47m@@@@@@@@@@@@@@@\033[0m    %%%%%%%%%  %%%   %%%  %%%  %%%%%%%%%\n"
"  \033[37;47m@@@@\033[0m              %%%%%%%%%  %%%   %%%  %%%  %%%%%%%%%\n"
"  \033[37;47m@@@@@@\033[0m            %%%        %%%%% %%%  %%%  %%%\n"
"  \033[37;47m@@@@@@@@@@\033[0m  \033[31;41mxx\033[0m    %%%        %%%%% %%%  %%%  %%%\n"
"  \033[37;47m@@@@@@@@@@@@@@\033[0m    %%%        %%%%% %%%% %%%  %%%\n"
"   \033[37;47m@@@@@@@@@@@\033[0m      %%%        %%%%% %%%% %%%  %%%\n"
"   \033[37;47m@@@@@@@@@\033[0m   .....%%%....... %%%%%%%%%%%%%%. %%%..........\n"
"     \033[37;47m@@@@@\033[0m          %%%        %%%%%%%%%%%%%%  %%%\n"
"     \033[37;47m@@@@\033[0m\n\n";

int setup_shutup=0;

int glob_argc;char**glob_argv;

extern void playtick();


void showsetup(char*z)
{
  if(!setup_shutup)
  {
/*while(*z){
    if(*z=='\r'){
      usleep(200000);
      fputs("\033[0;31m[\033[1m*\033[0;31m]\033[0m ",stderr);
      usleep(200000);z++;}else{
    fputc(*z++,stderr);
    usleep(20000);}
  }*/

  if(z[0]=='\r'){fprintf(stderr,"\033[0;31m[\033[1m*\033[0;31m]\033[0m ");z++;}
  fprintf(stderr,"%s",z);
  }
}

void showstartup()
{
  int y=7;
  if(!setup_shutup){
  showsetup("\rstarting up.... 2sec delay for ^C");
  sleep(2);
  for(;y;fprintf(stderr,"\e[%im\e[2J","(,*.-/"[--y]))usleep(99999);
  }
}

void showfinished()
{
  if(setup_shutup)return;
  fputs(pwpasciilogo,stderr);
  showsetup("\rshutting down multimedia subsystems\n");
  showsetup("\roperation finished - support pwp\n\n\n");
}

void fisimain()
{
    showsetup("\rfinal isi (1st at abduction '98 pc introcompo)\n");

    if(!pwplib_init())return;
    pwplib.videobuf.width=80;
    pwplib.videobuf.height=50;
      /* if(pwplib.videobuf<48)shrinkto25++; */
    if(!pwplib.setup[SETUP_NOSOUND])
      pwplib.player=playtick;
    precalx();
    showsetup(setup_english?"\rusing the english language\n"
                           :"\rpuhumme suomea\n");
    showstartup();
    demoloop();
    timer_off();
    showfinished();
}

int main(int argc,char**argv)
{
   int program=0;

   int i=0,quit=0;
   setup_force25=0;
   setup_english=1;

   pwplib.setup[SETUP_VOLUME]=32;
   pwplib.setup[SETUP_NOSOUND]=pwplib.setup[SETUP_NOVIDEO]=0;
   pwplib.setup[SETUP_COLORS]=2;
   pwplib.setup[SETUP_TRANS]=0;
   pwplib.setup[SETUP_HALVE]=0;
   pwplib.setup[SETUP_RASTER]=0;
   pwplib.setup[SETUP_TTY]=0;
   pwplib.setup[SETUP_BPS]=0;
   pwplib.setup[SETUP_FPS]=0;
   pwplib.setup[SETUP_LOSSY]=0;
   pwplib.setup[SETUP_PVP]=0;

   /* -> memcpy from defaults */

   for(;i<argc;i++)
   {
     char*s=argv[i];while(*s=='-')s++;

     switch((int)s[0])
     {
       case('h'):
       
         if(s[1]=='a')
           pwplib.setup[SETUP_HALVE]++;
         
         else
         {
         printf(
         "usage: %s [options] where options include:\n\n"

         "  help      this text\n"
         
         "\n"

         "  play      play .pvp animation from stdin\n"
         "  english   view demo text in english\n"
         "  finnish   view demo text in finnish\n"

         "\n"

         "  tty       output in ansi/vt102 codes (stderr)\n"
         "  pvp       output in pwp video phormat (stdout)\n"

         "\n"

         "  nosound   no sound\n"
         "  novideo   no video output\n"
         "  shutup    be quiet - only output the essentials\n"
         
         "\n"
         
         "  volume v  set soft volume to v (numeric, default 32)\n"
         "  colors x  color configuration: 0=16x16, 1=8fg 2=8bg, 3=8x8\n"
         "            8=monochrome, 9=vtattributes\n"
         "  trans n   charset: 1=ibm, 2=ascii, 3=ascii-pure\n"
         "  raster n  raster rendering mode: 0==fg+bg 1=fgonly 2=mono\n"
         "  ascii     pure ascii: no colors, no attributes\n"
         "  half      use half height (80x25)\n"

         "\n"

         "  bps n     fix to n bits per second, no delay\n"
         "  fps n     fix to n frames per second, no delay\n"
         "\n",argv[0]);
         quit=1;
         }
         break;

         /*
         "  stdin     read animation from stdin (formats: pvp, raw-vcsa or ansi)\n"
         "  pvp       output in pwp video phormat to stdout\n"
         "  mov       output in quicktime movie format\n"
         "  X11       use a dedicated X window\n"
         "  telnet p  use telnet negotiation in port n (0 == use stdin/stdout)\n"
         */

       case('e'):
         setup_english=1;
         break;
       case('f'):
         if(s[1]=='i')
         {
            setup_english=0;
         }
          else
         if(argv[i+1]!=NULL)
         {
           pwplib.setup[SETUP_FPS]=atoi(argv[i+1]);
           i++;
         }
         break;
       case('n'):
         if(s[2]=='s')
           pwplib.setup[SETUP_NOSOUND]++;else
           pwplib.setup[SETUP_NOVIDEO]++;
         break;
       case('s'):
         setup_shutup++;
         break;
       case('b'):
         if(argv[i+1]!=NULL)
         {
           pwplib.setup[SETUP_BPS]=atoi(argv[i+1]);
           i++;
         }break;
       case('v'):
         if(argv[i+1]!=NULL)
         {
           pwplib.setup[SETUP_VOLUME]=atoi(argv[i+1]);
           i++;
         }break;
       case('c'):
         if(argv[i+1]!=NULL)
         {
           pwplib.setup[SETUP_COLORS]=atoi(argv[i+1]);
           i++;
         }break;
       case('a'):
         pwplib.setup[SETUP_TRANS]=3;
         pwplib.setup[SETUP_COLORS]=8;
         pwplib.setup[SETUP_RASTER]=2;
         break;
/*       case('h'):
         pwplib.setup[SETUP_HALVE]++;
         break;*/
       case('r'):
         if(argv[i+1]!=NULL)
         {
           pwplib.setup[SETUP_RASTER]=atoi(argv[i+1]);
           i++;
         }break;
       case('p'):
         if(s[1]=='l')program=1;
          else
         pwplib.setup[SETUP_PVP]=1;
         break;
       case('t'):
         if(s[1]=='r')
         {
           if(argv[i+1]!=NULL)
           {
             pwplib.setup[SETUP_TRANS]=atoi(argv[i+1]);
             i++;
           }
         }else pwplib.setup[SETUP_TTY]++;
         break;
       case('l'):
         pwplib.setup[SETUP_LOSSY]++;
         break;
     }
   }
   if(!quit){
     if(!setup_shutup)fputs(pwpasciilogo,stderr);
     showsetup("\rpwplib/unix " VERSION" initializing ........\n");

     if(program)
        playpvp_run();
     else
        fisimain();
   }
   return 0;
}
